import ij.*;
import ij.plugin.filter.PlugInFilter;
import ij.process.*;



public class RGB_Exposure_Overlay implements PlugInFilter {

ImageStack stack;
	public int setup(String arg, ImagePlus imp) { 
	stack = imp.getStack(); 
	return DOES_RGB; 
	}

public void run(ImageProcessor ip) {


	int w = stack.getWidth();
	int h = stack.getHeight();

	int[] pixels =(int[]) ip.getPixels();

	int v = 0;
	int red = 0;
	int green = 0;
	int blue = 0;
	int satThreshold = 254;


	for(int j=0; j<w*h; j++){
		v = pixels[j];
		red = (v>>16)&0xff;
		green = (v>>8)&0xff;
		blue = v&0xff;
		
		if(red>satThreshold && green>satThreshold && blue>satThreshold)
			pixels[j] = 0x808080;
		else if(red>satThreshold && green>satThreshold)
			pixels[j] = 0x808002;
		else if(red>satThreshold && blue>satThreshold)
			pixels[j] = 0x800080;
		else if(green>satThreshold && blue>satThreshold)
			pixels[j] = 0x008080;
		else if(red>satThreshold)
			pixels[j] = 0x800002;
		else if(green>satThreshold)
			pixels[j] = 0x008002;
		else if(blue>satThreshold)
			pixels[j] = 0x000080;
		else pixels[j] = 0x000000;
	}//j

}
}
